#include <avr/io.h>
#include <avr/interrupt.h> 
#include <stdint.h>
#include "button.h"

/************************************************************************
 *
 * ISR TIMER1_COMPA_vectr for Mega 1284P
 * 
*************************************************************************/
ISR( TIMER1_COMPA_vect )  {           // 1ms for manual movement
	
			//button double-clicked 
			if (buttonPressed) {
				stateOfButton.flag0 = 1;  //
				timer1++;
			}				 			
		
			if (stateOfButton.flag0)	timer3++; // timer1 + timer2 < timer3 
		
			
			if ( (timer1 >20) && (timer1< 200) && !stateOfButton.flag1 && buttonReleased) { //250
				 stateOfButton.flag1 = 1;
				 timer1 = 0;
			}			
			
			if ((stateOfButton.flag1 && buttonPressed)) {
				stateOfButton.flag2 = 1;
				timer2++;
			}
			
			//timer3: max 500ms in sum
			if ( (timer3< 500) && ( timer2 > 20) && (timer2< 250) && stateOfButton.flag2 && stateOfButton.flag1 && buttonReleased) {
				stateOfButton.buttonDoubleClicked = 1;
				stateOfButton.flag0 = stateOfButton.flag1 = stateOfButton.flag2 = 0;
				timer1 = timer2 = timer3 = 0;
				timer4 = 0;
				stateOfButton.flag3 = stateOfButton.flag4 = 0;
				}				


			if (timer3 >=500) {
				stateOfButton.flag0 = stateOfButton.flag1 = stateOfButton.flag2 = stateOfButton.flag3 = stateOfButton.flag4 = 0;
				timer1 = timer2 = timer3 = 0;	
			}


  //button short pressed/long pressed
		if (buttonPressed) 
		{
		  stateOfButton.flag4 = 1;
		  stateOfButton.buttonLongTimePressed  = stateOfButton.buttonShortTimePressed = 0;		  		  
		}
		
	
			if (!stateOfButton.buttonLongTimePressed) {						
			if ((timer4 > 20) && (timer4 < 1000) && buttonReleased) {
					if(!timer2 && timer3 > 250) {  
							stateOfButton.buttonShortTimePressed = 1;			 
							timer4 = 0;
					}					
			}								
		}				
	
		if (timer4 >= 1000) {  //1000 = 1sec
			
				  stateOfButton.buttonLongTimePressed  = 1;			
				  stateOfButton.flag3 = 1;  //prepare for next cycle								
		}				
		
		if (stateOfButton.flag3) { 
				timer4 = 0;
				if (buttonReleased)  {
				stateOfButton.flag3 = 0;			
				}				
		}	

		//count timer
		if (stateOfButton.flag4 && !stateOfButton.flag3) timer4++;
		if (buttonReleased)  stateOfButton.flag4 = 0;
}
  

/************************************************************************
 *
 * encode_init fr Mega 1284P
 * 
 ************************************************************************/
void init(void)
{
  TCCR1B = (1<<WGM12) | (1<<CS11) | (1<<CS10);     // CTC, XTAL / 64  // *2,5 <- 20MHz!
  OCR1A  = (uint16_t)(F_CPU / 64.0 * 1e-3 - 0.5);   // 1ms
  TIMSK1 |= 1<<OCIE1A;

  //button pressed timers
  timer1 = timer2 = timer3 = timer4 = timer5 = 0; 
  
stateOfButton.flag0 = 0;
stateOfButton.flag1 = 0;
stateOfButton.flag2 = 0;
stateOfButton.flag3 = 0;
stateOfButton.flag4 = 0;
stateOfButton.buttonShortTimePressed = 0;
stateOfButton.buttonLongTimePressed = 0;
stateOfButton.buttonDoubleClicked = 0;

}

